package com.ibizlab.codegen.api;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.Accessors;

import java.util.Objects;
import java.util.StringJoiner;


@Getter
@Setter
@NoArgsConstructor
@Accessors(chain = true)
public class TemplateDefinition {
    private String templateFile;
    private String folder;
    private String destinationFilename;

    protected TemplateFileType templateType;

    public TemplateDefinition(String templateFile, String folder, String destinationFilename) {
        if (templateFile == null) throw new IllegalArgumentException("templateFile may not be null.");
        if (folder == null) throw new IllegalArgumentException("folder may not be null.");
        if (destinationFilename == null) throw new IllegalArgumentException("destinationFilename may not be null.");

        this.templateFile = templateFile;
        this.folder = folder;
        this.destinationFilename = destinationFilename;
        this.templateType = TemplateFileType.SupportingFiles;
    }
}
